﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WindowsFormsApplication6
{
    public partial class FittingLineInScreen : Form
    {
        private const String SHAPE_COLUMN_NAME = "Name";
        private TextStyle _textStyle;
        public FittingLineInScreen()
        {
            InitializeComponent();


            if (LicenseManager.UsageMode == LicenseUsageMode.Designtime) return;

            winformsMap1.ThreadingMode = MapThreadingMode.SingleThreaded;

            // Create a TextSymbol for shape's name.
            var font = new GeoFont("Arial", 9, DrawingFontStyles.Regular);
            var brush = new GeoSolidBrush(GeoColor.SimpleColors.Black);
            _textStyle = new TextStyle("Name", font, brush);
            //_textStyle.TextLineSegmentRatio = Double.MaxValue;
            //_textStyle.XOffsetInPixel = 5;
            //_textStyle.FittingPolygon = true;
            //_textStyle.ForceHorizontalLabelForLine = true;
            //_textStyle.LabelAllLineParts = true;
            //_textStyle.LabelAllPolygonParts = true;
            //_textStyle.OverlappingRule = LabelOverlappingRule.AllowOverlapping;
            //_textStyle.SplineType = SplineType.ForceSplining;
            //_textStyle.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels;
            _textStyle.FittingLineInScreen = true;
            //_textStyle.SuppressPartialLabels = false;

            // critical view
            winformsMap1.MaximumScale = 20000;
            winformsMap1.MinimumScale = 0.1;
            winformsMap1.MapUnit = GeographyUnit.Meter;

            winformsMap1.ZoomLevelSet.ZoomLevel01.Scale = 20000;
            winformsMap1.ZoomLevelSet.ZoomLevel02.Scale = winformsMap1.ZoomLevelSet.ZoomLevel01.Scale / 9 * 5; //11111.1111111111
            winformsMap1.ZoomLevelSet.ZoomLevel03.Scale = winformsMap1.ZoomLevelSet.ZoomLevel02.Scale / 9 * 5; //6172.83950617284
            winformsMap1.ZoomLevelSet.ZoomLevel04.Scale = winformsMap1.ZoomLevelSet.ZoomLevel03.Scale / 9 * 5; //3429.35528120713
            winformsMap1.ZoomLevelSet.ZoomLevel05.Scale = winformsMap1.ZoomLevelSet.ZoomLevel04.Scale / 9 * 5; //1905.19737844841
            winformsMap1.ZoomLevelSet.ZoomLevel06.Scale = winformsMap1.ZoomLevelSet.ZoomLevel05.Scale / 9 * 5; //1058.44298802689
            winformsMap1.ZoomLevelSet.ZoomLevel07.Scale = winformsMap1.ZoomLevelSet.ZoomLevel06.Scale / 9 * 5; //588.023882237163
            winformsMap1.ZoomLevelSet.ZoomLevel08.Scale = winformsMap1.ZoomLevelSet.ZoomLevel07.Scale / 9 * 5; //326.679934576202
            winformsMap1.ZoomLevelSet.ZoomLevel09.Scale = winformsMap1.ZoomLevelSet.ZoomLevel08.Scale / 9 * 5; //181.488852542334
            winformsMap1.ZoomLevelSet.ZoomLevel10.Scale = winformsMap1.ZoomLevelSet.ZoomLevel09.Scale / 9 * 5; //100.827140301297
            winformsMap1.ZoomLevelSet.ZoomLevel11.Scale = winformsMap1.ZoomLevelSet.ZoomLevel10.Scale / 9 * 5; //56.0150779451649
            winformsMap1.ZoomLevelSet.ZoomLevel12.Scale = winformsMap1.ZoomLevelSet.ZoomLevel11.Scale / 9 * 5; //31.1194877473138
            winformsMap1.ZoomLevelSet.ZoomLevel13.Scale = winformsMap1.ZoomLevelSet.ZoomLevel12.Scale / 9 * 5; //17.2886043040632
            winformsMap1.ZoomLevelSet.ZoomLevel14.Scale = winformsMap1.ZoomLevelSet.ZoomLevel13.Scale / 9 * 5; //9.60478016892402
            winformsMap1.ZoomLevelSet.ZoomLevel15.Scale = winformsMap1.ZoomLevelSet.ZoomLevel14.Scale / 9 * 5; //5.33598898273557
            winformsMap1.ZoomLevelSet.ZoomLevel16.Scale = winformsMap1.ZoomLevelSet.ZoomLevel15.Scale / 9 * 5; //2.96443832374198
            winformsMap1.ZoomLevelSet.ZoomLevel17.Scale = winformsMap1.ZoomLevelSet.ZoomLevel16.Scale / 9 * 5; //1.64691017985666
            winformsMap1.ZoomLevelSet.ZoomLevel18.Scale = winformsMap1.ZoomLevelSet.ZoomLevel17.Scale / 9 * 5; //0.914950099920365
            winformsMap1.ZoomLevelSet.ZoomLevel19.Scale = winformsMap1.ZoomLevelSet.ZoomLevel18.Scale / 9 * 5; //0.508305611066869
            winformsMap1.ZoomLevelSet.ZoomLevel20.Scale = winformsMap1.ZoomLevelSet.ZoomLevel19.Scale / 9 * 5; //0.282392006148261


            DrawGrids();
            winformsMap1.Refresh();
        }

        private void DrawGrids()
        {
            // create some dynamic layers
            const int gridIncrement = 20;
            var overlay1 = new LayerOverlay();

            // name the layers
            overlay1.Name = "OVERLAY_GRID";

            var lineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.FromArgb(64, 128, 128, 210), 1, true);
            var trajLength = 2000.0;

            // gridlayers
            var grid1000 = new InMemoryFeatureLayer();
            grid1000.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = lineStyle;
            grid1000.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid1000.Open();
            grid1000.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid1000.Close();
            var grid1000L = new InMemoryFeatureLayer();
            grid1000L.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = _textStyle;
            grid1000L.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid1000L.Open();
            grid1000L.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid1000L.Close();
            var grid500 = new InMemoryFeatureLayer();
            grid500.ZoomLevelSet.ZoomLevel08.DefaultLineStyle = lineStyle;
            grid500.ZoomLevelSet.ZoomLevel08.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid500.Open();
            grid500.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid500.Close();
            var grid500L = new InMemoryFeatureLayer();
            grid500L.ZoomLevelSet.ZoomLevel08.DefaultTextStyle = _textStyle;
            grid500L.ZoomLevelSet.ZoomLevel08.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid500L.Open();
            grid500L.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid500L.Close();
            var grid100 = new InMemoryFeatureLayer();
            grid100.ZoomLevelSet.ZoomLevel14.DefaultLineStyle = lineStyle;
            grid100.ZoomLevelSet.ZoomLevel14.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid100.Open();
            grid100.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid100.Close();
            var grid100L = new InMemoryFeatureLayer();
            grid100L.ZoomLevelSet.ZoomLevel14.DefaultTextStyle = _textStyle;
            grid100L.ZoomLevelSet.ZoomLevel14.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid100L.Open();
            grid100L.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid100L.Close();
            var grid10 = new InMemoryFeatureLayer();
            grid10.ZoomLevelSet.ZoomLevel18.DefaultLineStyle = lineStyle;
            grid10.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid10.Open();
            grid10.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid10.Close();
            var grid10L = new InMemoryFeatureLayer();
            grid10L.ZoomLevelSet.ZoomLevel18.DefaultTextStyle = _textStyle;
            grid10L.ZoomLevelSet.ZoomLevel18.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            grid10L.Open();
            grid10L.Columns.Add(new FeatureSourceColumn(SHAPE_COLUMN_NAME));
            grid10L.Close();

            // add grid lines
            for (var i = -100; i <= trajLength + 100; i += gridIncrement)
            {
                // make the line
                var ln = new LineShape();
                ln.Vertices.Add(new Vertex(i, 1000));
                ln.Vertices.Add(new Vertex(i, -1000));
                var feature = ln.GetFeature();
                feature.ColumnValues[SHAPE_COLUMN_NAME] = i.ToString("G");

                // make the shape
                if (i % 1000 == 0)
                {
                    grid1000.InternalFeatures.Add(feature);
                    grid1000L.InternalFeatures.Add(feature);
                }
                else if (i % 500 == 0)
                {
                    grid500.InternalFeatures.Add(feature);
                    grid500L.InternalFeatures.Add(feature);
                }
                else if (i % 100 == 0)
                {
                    grid100.InternalFeatures.Add(feature);
                    grid100L.InternalFeatures.Add(feature);
                }
                else if (i % 10 == 0)
                {
                    grid10.InternalFeatures.Add(feature);
                    grid10L.InternalFeatures.Add(feature);
                }
            }
            for (var j = -1000; j <= 1000; j += gridIncrement)
            {
                // make the line
                var ln = new LineShape();
                ln.Vertices.Add(new Vertex(-100, j));
                ln.Vertices.Add(new Vertex(trajLength + 100, j));
                var feature = ln.GetFeature();
                feature.ColumnValues[SHAPE_COLUMN_NAME] = j.ToString("G");

                // make the shape
                if (j % 1000 == 0)
                {
                    grid1000.InternalFeatures.Add(feature);
                    grid1000L.InternalFeatures.Add(feature);
                }
                else if (j % 500 == 0)
                {
                    grid500.InternalFeatures.Add(feature);
                    grid500L.InternalFeatures.Add(feature);
                }
                else if (j % 100 == 0)
                {
                    grid100.InternalFeatures.Add(feature);
                    grid100L.InternalFeatures.Add(feature);
                }
                else if (j % 10 == 0)
                {
                    grid10.InternalFeatures.Add(feature);
                    grid10L.InternalFeatures.Add(feature);
                }
            }

            overlay1.Layers.Add(grid1000);
            overlay1.Layers.Add(grid1000L);
            overlay1.Layers.Add(grid500);
            overlay1.Layers.Add(grid500L);
            overlay1.Layers.Add(grid100);
            overlay1.Layers.Add(grid100L);
            overlay1.Layers.Add(grid10);
            overlay1.Layers.Add(grid10L);

            // add the dynamic layers now
            winformsMap1.Overlays.Add(overlay1);
        }

        private void dostuff()
        {

            var font = new GeoFont("Arial", 9, DrawingFontStyles.Regular);
            var brush = new GeoSolidBrush(GeoColor.SimpleColors.Green);
            var textStyle = new TextStyle("Name", font, brush);
            //textStyle.FittingPolygon = true;
            //textStyle.ForceHorizontalLabelForLine = true;
            //textStyle.LabelAllLineParts = true;
            //textStyle.LabelAllPolygonParts = true;
            //textStyle.OverlappingRule = LabelOverlappingRule.AllowOverlapping;
            //textStyle.SplineType = SplineType.ForceSplining;
            //textStyle.DuplicateRule = LabelDuplicateRule.OneDuplicateLabelPerQuadrant;
            //textStyle.TextLineSegmentRatio = 1;
            textStyle.FittingLineInScreen = true;
            //textStyle.SuppressPartialLabels = false;

            var layer = new InMemoryFeatureLayer();
            layer.Open();
            layer.Columns.Add(new FeatureSourceColumn("Name"));
            layer.Close();
            layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.SimpleColors.Black, 3, true);
            layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            var layerPoly = new InMemoryFeatureLayer();
            layerPoly.Open();
            layerPoly.Columns.Add(new FeatureSourceColumn("Name"));
            layerPoly.Close();
            layerPoly.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Black, GeoColor.StandardColors.Red, 3);
            layerPoly.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            var layerLabels = new InMemoryFeatureLayer();
            layerLabels.Open();
            layerLabels.Columns.Add(new FeatureSourceColumn("Name"));
            layerLabels.Close();
            //layerLabels.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(textStyle);
            layerLabels.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = textStyle;
            layerLabels.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            var shapePoly = new PolygonShape();
            shapePoly.OuterRing.Vertices.Add(new Vertex(-15, 0));
            shapePoly.OuterRing.Vertices.Add(new Vertex(-5, 0));
            shapePoly.OuterRing.Vertices.Add(new Vertex(-5, 10));
            shapePoly.OuterRing.Vertices.Add(new Vertex(-15, 10));

            var shape = new LineShape();
            shape.Vertices.Add(new Vertex(0, 0));
            shape.Vertices.Add(new Vertex(10, 0));
            shape.Vertices.Add(new Vertex(10, 10));
            shape.Vertices.Add(new Vertex(0, 10));

            var feature = shape.GetFeature();
            feature.ColumnValues["Name"] = "test";

            var featurePoly = shapePoly.GetFeature();
            feature.ColumnValues["Name"] = "test";

            layer.InternalFeatures.Add(feature);
            layerPoly.InternalFeatures.Add(featurePoly);
            layerLabels.InternalFeatures.Add(feature);
            layerLabels.InternalFeatures.Add(featurePoly);

            var overlay = new LayerOverlay();
            overlay.Layers.Add(layer);
            overlay.Layers.Add(layerLabels);
            overlay.Layers.Add(layerPoly);

            winformsMap1.Overlays.Add(overlay);
            layer.Open();
            winformsMap1.CurrentExtent = layer.GetBoundingBox();
            layer.Close();
            winformsMap1.Refresh();
        }
    }
}
